import '../ParserType.dart';
import '../lexer/Lexer.dart';

/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 140
class Identifier extends ParserType {
  String val;

  Identifier(Lexer lexer) {
    checkType(lexer, TType.IDENTIFIER);
    val = lexer.currentToken.val;
    lexer.advance();
  }

  String toString() {
    return '$val';
  }
}
