import '../ParserType.dart';
import 'Identifier.dart';
import '../lexer/Lexer.dart';

/// <label> ::= <identifier> ':'
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 161
class Label extends ParserType {
  Identifier identifier;

  Label(Lexer lexer) {
    identifier = Identifier(lexer);
    checkType(lexer, TType.COLON);
    lexer.advance();
  }

  String toString() {
    return '$identifier:';
  }
}
