import 'enumns.dart';

class Token {
  TType _type;
  String _value;
  int _pos;

  Token(TType t, String v, int p) {
    _type = t;
    _value = v;
    _pos = p;
  }

  String toString() {
    return '(${typeToString()},$_value,$_pos)';
  }

  TType get type => _type;
  String get val => _value;
  int get pos => _pos;

  String typeToString([TType t]) {
    if (t == null) t = _type;
    switch (t) {
      case TType.COMMA:
        return "COMMA";
        break;
      case TType.PERIOD:
        return "PERIOD";
        break;
      case TType.NUMBER:
        return "NUMBER";
        break;
      case TType.HEX_NUMBER:
        return "HEX_NUMBER";
        break;
      case TType.BOOLEAN:
        return "BOOLEAN";
        break;
      case TType.LEFT_PAREN:
        return "LEFT_PAREN";
        break;
      case TType.RIGHT_PAREN:
        return "RIGHT_PAREN";
        break;
      case TType.LEFT_BRACKET:
        return "LEFT_BRACKET";
        break;
      case TType.RIGHT_BRACKET:
        return "RIGHT_BRACKET";
        break;
      case TType.LEFT_CURLY:
        return "LEFT_CURLY";
        break;
      case TType.RIGHT_CURLY:
        return "RIGHT_CURLY";
        break;
      case TType.LEFT_ANGLE:
        return "LEFT_ANGLE";
        break;
      case TType.RIGHT_ANGLE:
        return "RIGHT_ANGLE";
        break;
      case TType.SEMICOLON:
        return "SEMICOLON";
        break;
      case TType.COLON:
        return "COLON";
        break;
      case TType.IDENTIFIER:
        return "ID";
        break;
      case TType.KEYWORD:
        return "KEYWORD";
        break;
      case TType.STRING:
        return "STRING";
        break;
      case TType.COMMENT:
        return "COMMENT";
        break;
      case TType.WHITESPACE:
        return "WHITESPACE";
        break;
      case TType.KUKAC:
        return "KUKAC";
        break;
      case TType.Q_MARK:
        return "Q_MARK";
        break;
      case TType.PLUS:
        return "PLUS";
        break;
      case TType.MINUS:
        return "MINUS";
        break;
      case TType.MULTIPLY:
        return "MULTIPLY";
        break;
      case TType.DIVIDE:
        return "DIVIDE";
        break;
      case TType.EQUALS:
        return "EQUALS";
        break;
      case TType.PIPE:
        return "PIPE";
        break;
      case TType.AMPERSAND:
        return "AMPERSAND";
        break;
      case TType.HASH:
        return "HASH";
        break;
      case TType.DOLLAR:
        return "DOLLAR";
        break;
      case TType.PERCENT:
        return "PERCENT";
        break;
      case TType.CARAT:
        return "CARAT";
        break;
      case TType.EXCLAMATION:
        return "EXCLAMATION";
        break;
      case TType.TILDE:
        return "TILDE";
        break;
      case TType.EOF:
        return "EOF";
        break;
      case TType.UNDEFINED:
        return "UNDEFINED";
        break;
      default:
        return "UNKNOWN";
        break;
    }
  }
}
