import '../ParserType.dart';
import '../ParserExceptions.dart';
import '../lexer/Lexer.dart';
import '../main/Statement.dart';

/// <statements> ::= <statement>*
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 74
class Statements extends ParserType {
  List<Statement> statements;

  Statements(Lexer lexer) {
    // print ('Started Statements');

    statements = [];

    int snapShot;
    try {
      while (true) {
        snapShot = lexer.currentIndex;
        statements.add(Statement(lexer));
      }
    } on WrongTokenType {
      lexer.setPos(snapShot);
    }

    // print ('Finished Statements');
  }

  String toString() {
    String rtn = '';
    for (int i = 0; i < statements.length; ++i) {
      rtn += '${statements[i]} ';
    }
    return rtn.trim();
  }
}
