import '../ParserType.dart';
import '../lexer/Lexer.dart';
import '../sub_types/Assertion.dart';

/// <assertStatement> ::= <assertion> ';'
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 165

class AssertStatement extends ParserType {
  Assertion assertion;

  AssertStatement(Lexer lexer) {
    assertion = Assertion(lexer);

    checkType(lexer, TType.SEMICOLON);
    lexer.advance();
  }

  String toString() {
    return '$assertion;';
  }
}
