import '../ParserType.dart';
import '../lexer/Lexer.dart';
import '../lists/Statements.dart';

/// <block> ::= '{' <statements> '}'
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 17

class Block extends ParserType {
  Statements statements;

  Block(Lexer lexer) {
    checkType(lexer, TType.LEFT_CURLY);
    lexer.advance();

    statements = Statements(lexer);

    checkType(lexer, TType.RIGHT_CURLY);
    lexer.advance();
  }

  String toString() {
    return '{ $statements }';
  }
}
