import '../ParserType.dart';
import '../lexer/Lexer.dart';
import '../lists/TypeNotVoidList.dart';

/// <interfaces> ::= implements <typeNotVoidList>
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 50
class Interfaces extends ParserType {
  TypeNotVoidList typeNotVoidList;

  Interfaces(Lexer lexer) {
    checkType(lexer, TType.KEYWORD);
    checkVal(lexer, 'implements');
    lexer.advance();

    typeNotVoidList = TypeNotVoidList(lexer);
  }

  String toString() {
    return 'implements $typeNotVoidList';
  }
}
