import '../ParserType.dart';
import '../lexer/Lexer.dart';
import '../sub_types/FunctionBody.dart';
import '../sub_types/Signatures.dart';

/// <localFunctionDeclaration> ::= <functionSignature> <functionBody>
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 148

class LocalFunctionDeclaration extends ParserType {
  FunctionSignature functionSignature;
  FunctionBody functionBody;

  LocalFunctionDeclaration(Lexer lexer) {
    functionSignature = FunctionSignature(lexer);
    functionBody = FunctionBody(lexer);
  }

  String toString() {
    return '$functionSignature $functionBody';
  }
}
