import '../ParserType.dart';
import '../lexer/Lexer.dart';
import '../lists/TypeNotVoidList.dart';

/// <mixins> ::= with <typeNotVoidList>
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 47

class Mixins extends ParserType {
  TypeNotVoidList typeNotVoidList;

  Mixins(Lexer lexer) {
    checkType(lexer, TType.KEYWORD);
    checkVal(lexer, 'with');
    lexer.advance();

    typeNotVoidList = TypeNotVoidList(lexer);
  }

  String toString() {
    return 'with $typeNotVoidList';
  }
}
