import '../ParserType.dart';
import '../ParserExceptions.dart';
import '../lexer/Lexer.dart';
import '../lists/Arguments.dart';
import 'Types.dart';

/// <argumentPart> ::= <typeArguments>? <arguments>
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 116
class ArgumentPart extends ParserType {
  TypeArguments typeArguments;
  Arguments arguments;

  ArgumentPart(Lexer lexer) {
    int snapShot = lexer.currentIndex;
    try {
      typeArguments = TypeArguments(lexer);
    } on WrongTokenType {
      lexer.setPos(snapShot);
    }

    arguments = Arguments(lexer);
  }

  String toString() {
    return (typeArguments != null ? '$typeArguments' : '') + '$arguments';
  }
}
