import '../ParserType.dart';
import '../ParserExceptions.dart';
import '../lexer/Lexer.dart';
import '../lists/FormalParameterList.dart';
import '../lists/TypeParameters.dart';

/// <formalParameterPart> ::= <typeParameters>? <formalParameterList>
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 17
class FormalParameterPart extends ParserType {
  TypeParameters typeParameters;
  FormalParameterList formalParameterList;

  FormalParameterPart(Lexer lexer) {
    int snapShot = lexer.currentIndex;
    try {
      typeParameters = TypeParameters(lexer);
    } on WrongTokenType {
      lexer.setPos(snapShot);
    }

    formalParameterList = FormalParameterList(lexer);
  }

  String toString() {
    return (typeParameters != null ? '$typeParameters' : '') +
        '$formalParameterList';
  }
}
