import '../ParserType.dart';
import '../lexer/Lexer.dart';
import '../core/Identifier.dart';
import '../main/Expression.dart';

/// <staticFinalDeclaration> ::= <identifier> '=' <expression>
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 27
class StaticFinalDeclaration extends ParserType {
  Identifier identifier;
  Expression expression;

  StaticFinalDeclaration(Lexer lexer) {
    identifier = Identifier(lexer);

    checkType(lexer, TType.EQUALS);
    lexer.advance();

    expression = Expression(lexer);
  }

  String toString() {
    return '$identifier = $expression';
  }
}
