import '../ParserType.dart';
import '../lexer/Lexer.dart';
import '../lists/IdentifierList.dart';

/// <combinator> ::= show <identifierList> | hide <identifierList>
///
/// See https://dart.dev/guides/language/specifications/DartLangSpec-v2.2.pdf
/// Page 167
class Combinator extends ParserType {
  bool isShow;
  IdentifierList identifierList;

  Combinator(Lexer lexer) {
    checkType(lexer, TType.KEYWORD);
    if (isVal(lexer, 'show')) {
      isShow = true;
    } else if (isVal(lexer, 'hide')) {
      isShow = false;
    } else {
      checkVal(lexer, 'show');
    }
    lexer.advance();

    identifierList = IdentifierList(lexer);
  }

  String toString() {
    return (isShow ? 'show' : 'hide') + ' $identifierList';
  }
}
