import 'package:test/test.dart';
import 'test_lib.dart';

import 'package:source_parser/src/lexer/Lexer.dart';

import 'package:source_parser/src/main/EnumType.dart';

void main() {

  Lexer lexer = Lexer();

  test('Enum Entry', () {

    runTest(EnumEntry(lexer.parseStr('int')), 'int');
    runTest(EnumEntry(lexer.parseStr('someEntry')), 'someEntry');
    runTest(EnumEntry(lexer.parseStr('_someEntry')), '_someEntry');
    runTest(EnumEntry(lexer.parseStr('anotherEntry')), 'anotherEntry');

  });

  test('Enum Type', () {

    runTest(EnumType(lexer.parseStr('enum testEnum{int}')), 'enum testEnum { int }');
    runTest(EnumType(lexer.parseStr('enum Colors {blue,red,green,grey}')), 'enum Colors { blue, red, green, grey }');

  });
  
}
