import 'package:test/test.dart';
import 'test_lib.dart';

import 'package:source_parser/src/lexer/Lexer.dart';

import 'package:source_parser/src/lists/TypeParameters.dart';
import 'package:source_parser/src/main/TypeParameter.dart';

void main() {

  Lexer lexer = Lexer();

  test('Type Parameter', () {

    runTest(TypeParameter(lexer.parseStr('int')), 'int');
    runTest(TypeParameter(lexer.parseStr('someEntry')), 'someEntry');
    runTest(TypeParameter(lexer.parseStr('_someEntry')), '_someEntry');
    runTest(TypeParameter(lexer.parseStr('anotherEntry')), 'anotherEntry');

    runTest(TypeParameter(lexer.parseStr('int extends num')), 'int extends num');
    runTest(TypeParameter(lexer.parseStr('someEntry extends someType')), 'someEntry extends someType');
    runTest(TypeParameter(lexer.parseStr('_someEntry extends someOtherType')), '_someEntry extends someOtherType');
    runTest(TypeParameter(lexer.parseStr('anotherEntry extends anotherType')), 'anotherEntry extends anotherType');

  });

  test('Type Parameters', () {

    runTest(TypeParameters(lexer.parseStr('<int>')), '<int>');
    runTest(TypeParameters(lexer.parseStr('<someEntry>')), '<someEntry>');
    runTest(TypeParameters(lexer.parseStr('<_someEntry>')), '<_someEntry>');
    runTest(TypeParameters(lexer.parseStr('<anotherEntry>')), '<anotherEntry>');
    runTest(TypeParameters(lexer.parseStr('<int extends num>')), '<int extends num>');
    runTest(TypeParameters(lexer.parseStr('<someEntry extends someType>')), '<someEntry extends someType>');
    runTest(TypeParameters(lexer.parseStr('<_someEntry extends someOtherType>')), '<_someEntry extends someOtherType>');
    runTest(TypeParameters(lexer.parseStr('<anotherEntry extends anotherType>')), '<anotherEntry extends anotherType>');

    runTest(TypeParameters(lexer.parseStr('<int, num>')), '<int, num>');
    runTest(TypeParameters(lexer.parseStr('<someEntry, second, third, fourth>')), '<someEntry, second, third, fourth>');
    runTest(TypeParameters(lexer.parseStr('<_someEntry, _second>')), '<_someEntry, _second>');
    runTest(TypeParameters(lexer.parseStr('<int extends num, num>')), '<int extends num, num>');
    runTest(TypeParameters(lexer.parseStr('<someEntry extends someType, second extends third>')), '<someEntry extends someType, second extends third>');
    runTest(TypeParameters(lexer.parseStr('<anotherEntry extends anotherType, int , num extends fourth, another>')), '<anotherEntry extends anotherType, int, num extends fourth, another>');

  });
  
}
